<template>
    <div class="white-block">
        <div class="padding">
            <h3>Дополнительный телефон</h3>
        </div>
        <hr/>
        <div class="padding">
            <div class="row">
                <div class="columns four">
                    <label for="owner">Владелец телефона</label>
                    <multiselect v-model="owner"
                                 :options="fieldOwner"
                                 :searchable="false"
                                 :close-on-select="true"
                                 :show-labels="false"
                                 placeholder=""
                                 id="owner"
                                 :preserve-search="true"
                                 label="title"
                                 track-by="id"
                                 @input="indicateOwner"
                                 :vValidateRules="'required'"
                                 v-validate="'required'"
                                 name="owner"
                                 :class="getValidateClass('owner')"
                    >
                    </multiselect>
                    <validate-message v-show="vErrors.has('owner')">
                        {{ vErrors.first('owner') }}
                    </validate-message>
                </div>
                <div class="columns four">
                    <label for="additionalPhone">Телефон</label>
                    <input autocomplete="off"
                           type="tel"
                           name="additionalPhone"
                           id="additionalPhone"
                           v-validate="'required|mobilePhone'"
                           :class="getValidateClass('additionalPhone')"
                           v-model="$user.additionalPhone"
                           v-mask="'+7(###)###-####'"
                           placeholder="+7("
                           :guide="true"
                           :keepCharPositions="true"
                           data-code="additionalPhoneInvalidFormat"
                    >

                    <validate-message v-show="vErrors.has('additionalPhone')">
                        {{ vErrors.first('additionalPhone') }}
                    </validate-message>

                </div>

                <!-- @note: удалено из анкеты 25.01.2019 -->
                <!--<transition name="slide-fade" v-if="owner.title === 'Другой человек'">-->
                <!--<div class="columns four text-overflow">-->
                <!--<label for="additionalPhoneOwner">ФИО владельца телефона</label>-->
                <!--<input autocomplete="off"-->
                <!--type="text"-->
                <!--name="additionalPhoneOwner"-->
                <!--id="additionalPhoneOwner"-->
                <!--placeholder=""-->
                <!--v-model="$user.additionalPhoneOwner"-->
                <!--:class="getValidateClass('additionalPhoneOwner')"-->
                <!--v-validate="'required|min:2|max:50|cyrillic'"-->
                <!--data-code="additionalPhoneOwnerTooShort, additionalPhoneOwnerTooLong, additionalPhoneOwnerInvalidFormat"-->
                <!--/>-->
                <!--<validate-message v-show="vErrors.has('additionalPhoneOwner')">-->
                <!--{{ vErrors.first('additionalPhoneOwner') }}-->
                <!--</validate-message>-->

                <!--</div>-->
                <!--</transition>-->
            </div>
            <div class="row">
                <transition name="slide-fade">
                    <div class="warning-yellow-block"
                         v-if="owner.title === 'Другой человек' && !$store.getters.getAuthStatus">
                        <p>Укажите номер телефона вашего родственника, товарища, коллеги. Это повысит ваши шансы на
                            получение займа.</p>
                    </div>
                </transition>
            </div>
        </div>
    </div>
</template>

<script>
    import UserGetter from '@/mixins/User/UserGetterMixin'
    import UserSetter from '@/mixins/User/UserSetterMixin'
    import UserErrorText from '@/mixins/User/UserErrorTextMixin'
    import ValidateMessage from '@/components/Validators/ValidateMessage'
    import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
    import {REQUIRED_FIELD, MIN_LENGHT, MAX_LENGHT} from '@/components/Validators/CustomVeeValidateMessage'
    import Multiselect from '@/UI/Multiselect'

    export default {
        name: 'additional-phone',
        mixins: [
            UserGetter,
            UserSetter,
            UserErrorText,
            GetValidateClass,
        ],
        components: {
            ValidateMessage,
            Multiselect
        },
        props: {
            params: {
                default() {
                    return {
                        eventGetOwner: 'showOwner'
                    }
                }
            }
        },
        data() {
            return {
                owner: '',
                fieldOwner: [
                    {id: 1, title: 'Я владелец'},
                    {id: 2, title: 'Другой человек'}
                ]
            }
        },
        created() {
            this.$user.validate.step3.additionPhone = Object.keys(this.$validator.flags).reduce((acc, item) => acc && this.$validator.flags[item].valid, true)
        },
        mounted() {
            this.$validator.localize(REQUIRED_FIELD)
            this.$validator.localize(MIN_LENGHT)
            this.$validator.localize(MAX_LENGHT)
            if (this.$user.additionalPhoneOwner === this.$user.userInicial || this.$route.name === 'registration') {
                this.owner = this.fieldOwner[0];
                this.$user.additionalPhoneOwner = this.$user.userInicial;
            } else {
                this.owner = this.fieldOwner[1];
            }
        },
        updated() {
            this.$user.validate.step3.additionPhone = Object.keys(this.$validator.flags).reduce((acc, item) => acc && this.$validator.flags[item].valid, true)
        },
        methods: {
            indicateOwner(val) {
                if (val.id === 1) { // по-умолчанию - я
                    this.$user.additionalPhoneOwner = this.$user.userInicial;
                } else {
                    this.$user.additionalPhoneOwner = '';
                }
            }
        },


    }
</script>

<style scoped lang="scss">
    .slide-fade-enter-active {
        transition: all .3s ease;
    }

    .slide-fade-leave-active {
        transition: all .3s ease;
    }

    .slide-fade-enter, .slide-fade-leave-to {
        transform: translateY(10px);
        opacity: 0;
    }

    .slide-fade-leave-to {
        transform: translateY(10px);
        opacity: 0;
    }

    ::-webkit-input-placeholder {
        color: #DED3D3;
    }

    ::-moz-placeholder {
        color: #DED3D3;
    }

    :-ms-input-placeholder {
        color: #DED3D3;
    }

    :-moz-placeholder {
        color: #DED3D3;
    }

    .text-overflow {
        & label {
            text-overflow: ellipsis;
            width: 100%;
            overflow: hidden;
            white-space: nowrap;
        }
    }
</style>